#include "time.h"
#include "iteration.h"
#include "system.h"
#include "journal.h"

int TimeCheck()
{
	// If we still have time then continue.
	if ( TempsCenti() < timestop ) 
		return 0;

	if ( TempsCenti() > timestoplimit ) {
		return 1;
	}

	// Time's up, can we stop.
	// If the score is a little bit down, then add some time
	// to try to find another move.
	if ( prev_root_score - root_score >= 40 && !timeextension ) {
		journal.Log( "root_score = %d, prev_root_score = %d, timeextension = %d", root_score, prev_root_score, timeextension );
		timeextension = timeslot;
		journal.Log( "timeextension = %d", timeextension );
		timestop += timeextension;
		timeslot += timeextension;
		return 0;
	}

	// If the score is way down, than add alot of time since, we don't
	// care loosing by time cause we already are in a lost position.
    if ( prev_root_score - root_score >= 500 && !timeextension ) {
		journal.Log( "root_score = %d, prev_root_score = %d, timeextension = %d", root_score, prev_root_score, timeextension );
		timeextension = timeslot*5;
		journal.Log( "timeextension = %d", timeextension );
		timestop += timeextension;
		timeslot += timeextension;
		return 0;
	}

	return 1;
}
